(function(angular) {
    'use strict';
    angular.module('FileManagerApp').provider('fileManagerConfig', function() {

        var values = {
            appName: 'File Commander PC File Transfer',
            defaultLang: 'en',

            listUrl: '/fm/listUrl',
            uploadUrl: '/fm/uploadUrl',
            renameUrl: '/fm/renameUrl',
            copyUrl: '/fm/copyUrl',
            moveUrl: '/fm/moveUrl',
            removeUrl: '/fm/removeUrl',
            editUrl: '/fm/editUrl',
            getContentUrl: '/fm/getContentUrl',
            createFolderUrl: '/fm/createFolderUrl',
            downloadFileUrl: '/fm/downloadFileUrl',
            downloadMultipleUrl: '/fm/downloadMultipleUrl',
            compressUrl: '/fm/compressUrl',
            extractUrl: '/fm/extractUrl',
            permissionsUrl: '/fm/permissionsUrl',

            searchForm: true,
            sidebar: true,
            breadcrumb: true,
            allowedActions: {
                upload: true,
                rename: false,
                move: false,
                copy: false,
                edit: true,
                changePermissions: false,
                compress: false,
                compressChooseName: false,
                extract: false,
                download: true,
                downloadMultiple: true,
                preview: true,
                remove: true
            },

            multipleDownloadFileName: 'PC File Transfer Files.zip',
            showSizeForDirectories: false,
            useBinarySizePrefixes: false,
            downloadFilesByAjax: true,
            previewImagesInModal: true,
            enablePermissionsRecursive: false,
            compressAsync: false,
            extractAsync: false,
            hidePermissions: true,

            isEditableFilePattern: /\.(txt|diff?|patch|svg|asc|cnf|cfg|conf|html?|.html|cfm|cgi|aspx?|ini|pl|py|md|css|cs|js|jsp|log|htaccess|htpasswd|gitignore|gitattributes|env|json|atom|eml|rss|markdown|sql|xml|xslt?|sh|rb|as|bat|cmd|cob|for|ftn|frm|frx|inc|lisp|scm|coffee|php[3-6]?|java|c|cbl|go|h|scala|vb|tmpl|lock|go|yml|yaml|tsv|lst)$/i,
            isImageFilePattern: /\.(jpe?g|gif|bmp|png|svg|tiff?)$/i,
            isExtractableFilePattern: /\.(gz|tar|rar|g?zip)$/i,
            tplPath: 'src/templates'
        };

        return {
            $get: function() {
                return values;
            },
            set: function (constants) {
                angular.extend(values, constants);
            }
        };

    });
})(angular);
